; compiler          : jal 0.4.62
; date              : 19-Nov-2006 10:07:44
; main source       : flashled
; command line      : -slib flashled.jal 
; target  chip      : 16f628
;         cpu       : pic 14
;         clock     : 10000000
; input   files     : 12
;         lines     : 2341
;         chars     : 61788
; compilation nodes : 13756
;             stack : 19Kb
;              heap : 4156Kb
;           seconds : 0.400 (5852 lines/second)
; output       code :  312
;              page :    0 (0.0%)
;              bank :    0 (0.0%)
;         page+bank :    0 (0.0%)
;              file :   15
;              stack:    2 (2,0,0)

 errorlevel -306
 list p=PIC16f628

; note: the f628 config is still fixed!
 __CONFIG H'3F10' 
 ORG 0000
  goto    __main
 ORG 0004
 ORG 0004
__interrupt: ; 0004
__main: ; 0004
; var H'020:000'  transfer_bit
; var H'021:000'  transfer_byte

;; 294 : var byte trisa
; var H'022:000' trisa

;; 295 : var byte trisb
; var H'023:000' trisb

;; 302 : trisa = all_input
  movlw   H'FF'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'022'

;; 304 :    trisb = all_input
  movlw   H'FF'
  movwf   H'023'

;; 610 : var byte _port_a_buffer
; var H'024:000' _port_a_buffer

;; 011 : pin_a0_direction = output
  bcf     H'022',0
  call    _3317__vector

;; 012 : pin_a1_direction = output
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'022',1
  call    _3346__vector

;; 013 : pin_a2_direction = output
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'022',2
  call    _3375__vector

;; 041 : var bit t = off
; var H'020:001' t
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'020',1

;; 043 : forever loop
w_12797_ag: ; 0017

;; 044 : 	t = on
  bcf     H'003',5
  bcf     H'003',6
  bsf     H'020',1

;; 045 : 	for 3 loop
; var H'025:000' _loop_temp_12621
  movlw   H'03'
  movwf   H'025'
f_12621_again: ; 001C

;; 046 : 		pin_a0 = on
  bsf     H'024',0
  call    _6253__vector

;; 047 : 		pin_a1 = on
  bcf     H'003',5
  bcf     H'003',6
  bsf     H'024',1
  call    _6282__vector

;; 048 : 		pin_a2 = on
  bcf     H'003',5
  bcf     H'003',6
  bsf     H'024',2
  call    _6311__vector

;; 050 : 		delay_ms( 100 )
  movlw   H'64'
  call    _12504__vector

;; 052 : 		pin_a0 = off
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'024',0
  call    _6253__vector

;; 053 : 		pin_a1 = off
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'024',1
  call    _6282__vector

;; 054 : 		pin_a2 = off
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'024',2
  call    _6311__vector

;; 056 : 		delay_ms( 100 )
  movlw   H'64'
  call    _12504__vector

  bcf     H'003',5
  bcf     H'003',6
  decfsz  H'025',f
  goto    f_12621_again

;; 059 : 	delay_ms( 100 )
  movlw   H'64'
  call    _12504__vector

;; 061 : 	for 3 loop
; var H'025:000' _loop_temp_12696
  movlw   H'03'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'025'
f_12696_again: ; 0040

;; 062 : 		pin_a0 = on
  bsf     H'024',0
  call    _6253__vector

;; 063 : 		delay_ms( 50 )
  movlw   H'32'
  call    _12504__vector

;; 064 : 		pin_a0 = off
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'024',0
  call    _6253__vector

;; 065 : 		delay_ms( 50 )
  movlw   H'32'
  call    _12504__vector

  bcf     H'003',5
  bcf     H'003',6
  decfsz  H'025',f
  goto    f_12696_again

;; 068 : 	delay_sec( 1 )
  movlw   H'01'
  call    _12537__vector

;; 070 : 	for 11 loop
; var H'025:000' _loop_temp_12751
  movlw   H'0B'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'025'
f_12751_again: ; 0054

;; 071 : 		toggle( t )
  call    _12576__vector
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'020',1
  btfss   H'020',2
  goto    ass_12759_f
ass_12759_t: ; 005A
  bsf     H'020',1
ass_12759_f: ; 005B

;; 072 : 		pin_a0 = t
  bcf     H'024',0
  btfss   H'020',1
  goto    ass_13003_f
ass_13003_t: ; 005E
  bsf     H'024',0
ass_13003_f: ; 005F
  call    _6253__vector

;; 073 : 		delay_ms(10)
  movlw   H'0A'
  call    _12504__vector

  bcf     H'003',5
  bcf     H'003',6
  decfsz  H'025',f
  goto    f_12751_again

;; 076 : 	delay_ms(200)
  movlw   H'C8'
  call    _12504__vector
  goto    w_12797_ag

;; 003 :   idle_loop: page goto idle_loop
as_12800_idle_loop: ; 0069
  goto    as_12800_idle_loop
_12576__vector: ; 006A

;; 032 : procedure toggle( bit out t ) is
; var H'020:002' t
p_12576_toggle: ; 006A
  bcf     H'003',5
  bcf     H'003',6

;; 033 : 	if t then
  btfss   H'020',2
  goto    if_12585_el
if_12585_th: ; 006E

;; 034 : 		t = off
  bcf     H'003',5
  bcf     H'003',6
  bcf     H'020',2
  goto    if_12585_by
if_12585_el: ; 0072

;; 036 : 		t = on
  bcf     H'003',5
  bcf     H'003',6
  bsf     H'020',2
if_12585_by: ; 0075
e_12576_toggle: ; 0075
  return  
_12537__vector: ; 0076

;; 024 : procedure delay_sec( byte in sec ) is
; var H'025:000' sec
p_12537_delay_sec: ; 0076
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'025'

;; 025 : 	for sec loop
; var H'026:000' _loop_temp_12551
  bcf     H'003',5
  bcf     H'003',6
  movf    H'025',w
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'026'
w_12910_ag: ; 007F
  bcf     H'003',5
  bcf     H'003',6
  movf    H'026',f
  btfss   H'003',2
  goto    w_12910_bo
w_12910_jb: ; 0084
  goto    w_12910_be
w_12910_bo: ; 0085

;; 026 : 		for 3 loop
; var H'027:000' _loop_temp_12555
  movlw   H'03'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'027'
f_12555_again: ; 0089

;; 459 : procedure delay_100ms( byte in x = 1 ) is
  movlw   H'01'

;; 027 : 			delay_100ms
  call    _10531__vector

  bcf     H'003',5
  bcf     H'003',6
  decfsz  H'027',f
  goto    f_12555_again
  bcf     H'003',5
  bcf     H'003',6
  decf    H'026',f
  goto    w_12910_ag
w_12910_be: ; 0093
e_12537_delay_sec: ; 0093
  return  
_12504__vector: ; 0094

;; 018 : procedure delay_ms( byte in millisec ) is
; var H'026:000' millisec
p_12504_delay_ms: ; 0094
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'026'

;; 019 : 	for millisec loop
; var H'027:000' _loop_temp_12518
  bcf     H'003',5
  bcf     H'003',6
  movf    H'026',w
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'027'
w_12874_ag: ; 009D
  bcf     H'003',5
  bcf     H'003',6
  movf    H'027',f
  btfss   H'003',2
  goto    w_12874_bo
w_12874_jb: ; 00A2
  goto    w_12874_be
w_12874_bo: ; 00A3

;; 435 : procedure delay_1ms( byte in x = 1 ) is
  movlw   H'01'

;; 020 : 			delay_1ms
  call    _10261__vector

  bcf     H'003',5
  bcf     H'003',6
  decf    H'027',f
  goto    w_12874_ag
w_12874_be: ; 00A9
e_12504_delay_ms: ; 00A9
  return  
_10531__vector: ; 00AA

;; 459 : procedure delay_100ms( byte in x = 1 ) is
; var H'028:000' x
p_10531_delay_100ms: ; 00AA
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'028'

;; 460 :    _delay_100us( x, 100, 10 )
  bcf     H'003',5
  bcf     H'003',6
  movf    H'028',w
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'029'
  movlw   H'64'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'02A'
  movlw   H'0A'
  goto    _9717__vector
e_10531_delay_100ms: ; 00B9
_10261__vector: ; 00B9

;; 435 : procedure delay_1ms( byte in x = 1 ) is
; var H'028:000' x
p_10261_delay_1ms: ; 00B9
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'028'

;; 436 :    _delay_100us( x, 10, 1 )
  bcf     H'003',5
  bcf     H'003',6
  movf    H'028',w
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'029'
  movlw   H'0A'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'02A'
  movlw   H'01'
  goto    _9717__vector
e_10261_delay_1ms: ; 00C8
_9717__vector: ; 00C8

;; 283 : procedure _delay_100us( byte in x, byte in y, byte in z ) is
; var H'029:000' x
; var H'02A:000' y
; var H'02B:000' z
p_9717__delay_100us: ; 00C8
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'02B'

;; 337 :       var byte minus_one = -1
; var H'02C:000' minus_one
  movlw   H'FFFFFFFF'
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'02C'

;; 339 :       var byte xx, yy
; var H'02D:000' xx
; var H'02E:000' yy

;; 343 :          local loop_x, loop_y, loop_z, loop_w
; const H'0D4' loop_w

;; 346 :       loop_z:
as_9935_loop_z: ; 00CF

;; 349 :          movfw y
  movf    H'02A',w

;; 350 :          movwf yy
  movwf   H'02E'

;; 351 :       loop_y:
as_9932_loop_y: ; 00D1

;; 354 :          movfw x
  movf    H'029',w

;; 355 :          movwf xx
  movwf   H'02D'

;; 356 :       loop_x:
as_9929_loop_x: ; 00D3

;; 358 :          movlw inner_iterations
  movlw   H'3B'

;; 360 :       loop_w:
as_9938_loop_w: ; 00D4

;; 361 :          addwf minus_one, w
  addwf   H'02C',w

;; 362 :          skpnc
  skpnc   

;; 363 :             goto loop_w
  goto    as_9938_loop_w

;; 366 :          decfsz xx, f
  decfsz  H'02D',f

;; 367 :          goto loop_x
  goto    as_9929_loop_x

;; 370 :          decfsz yy, f
  decfsz  H'02E',f

;; 371 :          goto loop_y
  goto    as_9932_loop_y

;; 374 :          decfsz z, f
  decfsz  H'02B',f

;; 375 :          goto loop_z
  goto    as_9935_loop_z
e_9717__delay_100us: ; 00DD
  return  

;; 726 : procedure pin_a2'put( bit in x at _port_a_buffer : 2 ) is
p_6311__pin_a2__put_t: ; 00DE
_6311__vector: ; 00DE
; var H'024:002' x
p_6311_put: ; 00DE

;; 727 :    _port_a_flush
  goto    _5326__vector
e_6311_put: ; 00DF

;; 723 : procedure pin_a1'put( bit in x at _port_a_buffer : 1 ) is
p_6282__pin_a1__put_t: ; 00DF
_6282__vector: ; 00DF
; var H'024:001' x
p_6282_put: ; 00DF

;; 724 :    _port_a_flush
  goto    _5326__vector
e_6282_put: ; 00E0

;; 720 : procedure pin_a0'put( bit in x at _port_a_buffer : 0 ) is
p_6253__pin_a0__put_t: ; 00E0
_6253__vector: ; 00E0
; var H'024:000' x
p_6253_put: ; 00E0

;; 721 :    _port_a_flush
  goto    _5326__vector
e_6253_put: ; 00E1
_5326__vector: ; 00E1
p_5326__port_a_flush: ; 00E1

;; 617 :    var volatile byte port_a_ at 5 = _port_a_buffer
; var H'005:000' port_a_
  bcf     H'003',5
  bcf     H'003',6
  movf    H'024',w
  bcf     H'003',5
  bcf     H'003',6
  movwf   H'005'
e_5326__port_a_flush: ; 00E7
  return  

;; 391 : procedure pin_a2_direction'put( bit in d at trisa : 2 ) is
p_3375__pin_a2_direction__put_t: ; 00E8
_3375__vector: ; 00E8
; var H'022:002' d
p_3375_put: ; 00E8

;; 392 :    _trisa_flush
  goto    _2925__vector
e_3375_put: ; 00E9

;; 388 : procedure pin_a1_direction'put( bit in d at trisa : 1 ) is
p_3346__pin_a1_direction__put_t: ; 00E9
_3346__vector: ; 00E9
; var H'022:001' d
p_3346_put: ; 00E9

;; 389 :    _trisa_flush
  goto    _2925__vector
e_3346_put: ; 00EA

;; 385 : procedure pin_a0_direction'put( bit in d at trisa : 0 ) is
p_3317__pin_a0_direction__put_t: ; 00EA
_3317__vector: ; 00EA
; var H'022:000' d
p_3317_put: ; 00EA

;; 386 :    _trisa_flush
  goto    _2925__vector
e_3317_put: ; 00EB
_2925__vector: ; 00EB
p_2925__trisa_flush: ; 00EB

;; 316 :       bank movfw trisa
  bcf     H'003',5
  bcf     H'003',6
  movf    H'022',w

;; 317 :            tris  5
  tris    H'005'
e_2925__trisa_flush: ; 00EF
  return  

 END

; ********** variable mapping
; 05:0 : ;
;   port_a_                        * 0617:22 lib/jpic.jal 
; 20:0 : ;
;    transfer_bit                    
; 20:1 : ;
;   t                                0041:09 flashled.jal 
; 20:2 : ;
;   t                                0032:19 flashled.jal 
; 21:0 : ;
;    transfer_byte                   
; 22:0 : ;
;   d                              * 0385:33 lib/jpic.jal 
;   trisa                            0294:10 lib/jpic.jal 
; 22:1 : ;
;   d                              * 0388:33 lib/jpic.jal 
; 22:2 : ;
;   d                              * 0391:33 lib/jpic.jal 
; 23:0 : ;
;   trisb                            0295:10 lib/jpic.jal 
; 24:0 : ;
;   x                              * 0720:23 lib/jpic.jal 
;   _port_a_buffer                   0610:10 lib/jpic.jal 
; 24:1 : ;
;   x                              * 0723:23 lib/jpic.jal 
; 24:2 : ;
;   x                              * 0726:23 lib/jpic.jal 
; 25:0 : ;
;   sec                              0024:22 flashled.jal 
;   _loop_temp_12751                 0070:02 flashled.jal 
;   _loop_temp_12696                 0061:02 flashled.jal 
;   _loop_temp_12621                 0045:02 flashled.jal 
; 26:0 : ;
;   millisec                         0018:21 flashled.jal 
;   _loop_temp_12551                 0025:02 flashled.jal 
; 27:0 : ;
;   _loop_temp_12518                 0019:02 flashled.jal 
;   _loop_temp_12555                 0026:03 flashled.jal 
; 28:0 : ;
;   x                                0435:22 lib/jdelay.jal 
;   x                                0459:24 lib/jdelay.jal 
; 29:0 : ;
;   x                                0283:25 lib/jdelay.jal 
; 2A:0 : ;
;   y                                0283:36 lib/jdelay.jal 
; 2B:0 : ;
;   z                                0283:47 lib/jdelay.jal 
; 2C:0 : ;
;   minus_one                        0337:16 lib/jdelay.jal 
; 2D:0 : ;
;   xx                               0339:16 lib/jdelay.jal 
; 2E:0 : ;
;   yy                               0339:20 lib/jdelay.jal 

